/**
 * DREAM
 * Copyright (C) 2003 2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: dream@objectweb.org
 *
 * Initial developer(s): Matthieu Leclercq
 * Contributor(s): 
 */

package org.objectweb.dream.control.logger;

/**
 * This interface define a method to <i>internally </i> set the logger base
 * name. The <code>internalSetBaseName</code> has effect only if the
 * {@link LoggerController#setBaseName(String) setBaseName }method has not been
 * called. This allows to set the logger base name to reflect the component
 * hierarchy, only if the base name was not set else where.
 * 
 * @see org.objectweb.dream.control.logger.LoggerLifeCycleCoordinatorMixin
 */
public interface LoggerInternalBaseName
{

  /**
   * Set logger base name. This has effect only if the
   * {@link LoggerController#setBaseName(String) setBaseName }method has not
   * been called.
   * 
   * @param name the logger base name.
   */
  void internalSetBaseName(String name);
}