/**
 * Copyright (C) 2002
 */

package org.objectweb.util.monolog.wrapper.log4jMini;

import org.objectweb.util.monolog.file.api.Pattern;

/**
 * This tools class permits to convert the printing pattern between log4j
 * and monolog.
 *
 * @author Sebastien Chassande-Barrioz
 */
public class PatternConverter implements Pattern {

	public static String monolog2log4j(String p) {
		String res = new String(p);
		int percentPos = res.indexOf('%', 0);
		boolean end = (percentPos == -1);
		int nextPercentPos = 0;
		while (!end) {
			nextPercentPos = res.indexOf('%', percentPos + 1);
			if (nextPercentPos == -1) {
				nextPercentPos = res.length();
				end = true;
			}
			for (int i = percentPos + 1; i < nextPercentPos; i++) {
				char el = res.charAt(i);
				if (el == Pattern.LEVEL) {
					res = substitute(res, 'p', i);
					break;
				}
				else if (el == Pattern.OBJECT) {
					res = substitute(res, 'C', i);
					break;
				}
				else if (el == Pattern.THREAD) {
					res = substitute(res, 't', i);
					break;
				}
				else if (el == Pattern.TOPIC) {
					res = substitute(res, 'c', i);
					break;
				}
				else if(Character.isLetter(el)) {
					break;
				}
			}
			percentPos = nextPercentPos;
		}
		return res;
	}

	public static String log4j2monolog(String p) {
		String res = new String(p);
		int percentPos = res.indexOf('%', 0);
		boolean end = (percentPos == -1);
		int nextPercentPos = 0;
		while (!end) {
			nextPercentPos = res.indexOf('%', percentPos + 1);
			if (nextPercentPos == -1) {
				nextPercentPos = res.length();
				end = true;
			}
			for (int i = percentPos + 1; i < nextPercentPos; i++) {
				char el = res.charAt(i);
				if (el == 'p') {
					res = substitute(res, Pattern.LEVEL, i);
					break;
				}
				else if (el == 'C') {
					res = substitute(res, Pattern.OBJECT, i);
					break;
				}
				else if (el == 't') {
					res = substitute(res, Pattern.THREAD, i);
					break;
				}
				else if (el == 'c') {
					res = substitute(res, Pattern.TOPIC, i);
					break;
				}
			}
			percentPos = nextPercentPos;
		}
		return res;
	}

	private static String substitute(String s, char c, int pos) {
		if (s == null)
			return null;
		if (s.length() <= pos)
			return s;
		return s.substring(0, pos) + c + s.substring(pos + 1, s.length());
	}
}
